> For the complete documentation index, see [llms.txt](https://docs.flosum.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.flosum.com/api/api-es/api-de-devops/activities.md).

# Activities

## Get list of activities

> Returns a paginated list of activities for the specified resource.

```json
{"openapi":"3.0.0","info":{"title":"Flosum Devops Api","version":"1.136.0-dev.5"},"security":[{"access-token":[]}],"components":{"securitySchemes":{"access-token":{"scheme":"bearer","bearerFormat":"JWT","type":"http","description":"Bearer access_token"}},"schemas":{"ListActivitiesResponseDto":{"type":"object","properties":{"count":{"type":"number","description":"Total number of jobs matching the filter"},"rows":{"description":"Paginated list of activity rows","type":"array","items":{"$ref":"#/components/schemas/ActivityRowDto"}}},"required":["count","rows"]},"ActivityRowDto":{"type":"object","properties":{"id":{"type":"number","description":"Job ID"},"type":{"$ref":"#/components/schemas/JobType"},"status":{"$ref":"#/components/schemas/JobStatus"},"source":{"description":"Source entity. Null if not applicable.","nullable":true,"allOf":[{"$ref":"#/components/schemas/SourceTargetDto"}]},"target":{"description":"Target entity. Null if not applicable.","nullable":true,"allOf":[{"$ref":"#/components/schemas/SourceTargetDto"}]},"createdBy":{"description":"User who created the job. Null if the user no longer exists.","nullable":true,"allOf":[{"$ref":"#/components/schemas/UserRecordDto"}]},"createdAt":{"format":"date-time","type":"string","description":"Date and time when the job was created"},"duration":{"type":"string","description":"Job execution duration in HH:MM:SS format. Null if job has not completed yet.","nullable":true}},"required":["id","type","status","source","target","createdBy","createdAt","duration"]},"JobType":{"type":"string","description":"Activity type.","enum":["Retrieve","Commit To Branch","Deploy","Search Conflicts","Validate","Merge","Pre-Deploy Fix Search","Pre-Deploy Fix Retrieve","Pre-Deploy Fix Remove","Rollback","Overwrite Protection","WebHook","Code Scan","Execute Apex","Push to Git","Pull from Git","Quick Deploy","Notify Unregistered Users","Notify Users Activity Digest","Retrieve Component Users","Migration","Pre-Deploy Fix Update","Migrate Data","Search and Replace Text"]},"JobStatus":{"type":"string","description":"Current execution status of the activity.","enum":["In Progress","Partially Completed","Exception","Completed","Aborted","Queued"]},"SourceTargetDto":{"type":"object","properties":{"id":{"type":"number","description":"Entity ID. Null for Git type.","nullable":true},"type":{"$ref":"#/components/schemas/SourceTargetType"},"name":{"type":"string","description":"Entity name"},"metadata":{"description":"Additional metadata. Populated for Organization type only. Null for Branch and Git types.","nullable":true,"allOf":[{"$ref":"#/components/schemas/SourceTargetMetadataDto"}]}},"required":["id","type","name"]},"SourceTargetType":{"type":"string","description":"Entity type","enum":["Branch","Organization","Git"]},"SourceTargetMetadataDto":{"type":"object","properties":{"organizationType":{"type":"string","description":"Salesforce org type"},"connectionType":{"type":"string","description":"Connection type"},"environment":{"type":"string","description":"Environment label"},"assignApps":{"description":"Apps assigned to this org","allOf":[{"$ref":"#/components/schemas/AssignAppsDto"}]},"externalId":{"type":"string","description":"Salesforce org external ID"}},"required":["organizationType","connectionType","environment","assignApps","externalId"]},"AssignAppsDto":{"type":"object","properties":{"backupAndArchive":{"type":"boolean","description":"Whether Backup & Archive app is assigned"},"devOps":{"type":"boolean","description":"Whether DevOps app is assigned"},"dataMigrator":{"type":"boolean","description":"Whether Data Migrator app is assigned"}},"required":["backupAndArchive","devOps","dataMigrator"]},"UserRecordDto":{"type":"object","properties":{"id":{"type":"number"},"name":{"type":"string"}},"required":["id","name"]},"ValidationExceptionDto":{"type":"object","properties":{"message":{"type":"array","items":{"type":"string"}},"error":{"type":"string","nullable":true},"statusCode":{"type":"number","enum":[100,101,102,103,200,201,202,203,204,205,206,300,301,302,303,304,307,308,400,401,402,403,404,405,406,407,408,409,410,411,412,413,414,415,416,417,418,421,422,424,428,429,500,501,502,503,504,505]}},"required":["message","error","statusCode"]},"ExceptionDto":{"type":"object","properties":{"message":{"type":"string"},"error":{"type":"string"},"statusCode":{"type":"number","enum":[400,401,403,404,405,406,408,409,410,412,413,414,415,418,420,422,428,429,431,500,502,503,504]}},"required":["message","error","statusCode"]}}},"paths":{"/topologies/{topologyId}/activities":{"get":{"operationId":"ActivitiesController_list","summary":"Get list of activities","description":"Returns a paginated list of activities for the specified resource.","parameters":[{"name":"topologyId","required":true,"in":"path","schema":{"type":"number"}},{"name":"entityId","required":false,"in":"query","description":"Identifier of the resource whose activities are requested.","schema":{"type":"number"}},{"name":"entityType","required":false,"in":"query","description":"Type of the resource whose activities are requested.","schema":{"enum":["Branch","Organization","Git"],"type":"string"}},{"name":"filterEntityIds","required":false,"in":"query","description":"Filter by related resource IDs. Semicolon-separated list of numbers.","schema":{"type":"string"}},{"name":"filterEntityType","required":false,"in":"query","description":"Type of related resources. Required if filterEntityIds is provided.","schema":{"enum":["Branch","Organization"],"type":"string"}},{"name":"types","required":false,"in":"query","description":"Filter by activity types. Semicolon-separated list.","schema":{"type":"string"}},{"name":"statuses","required":false,"in":"query","description":"Filter by activity statuses. Semicolon-separated list.","schema":{"type":"string"}},{"name":"startDate","required":false,"in":"query","description":"Filter by job creation date range — start of range (inclusive)","schema":{"format":"date-time","type":"string"}},{"name":"endDate","required":false,"in":"query","description":"Filter by job creation date range — end of range (inclusive)","schema":{"format":"date-time","type":"string"}},{"name":"createdByIds","required":false,"in":"query","description":"Filter by creator IDs. Semicolon-separated list.","schema":{"type":"string"}},{"name":"offset","required":true,"in":"query","description":"Number of records to skip","schema":{"minimum":0,"type":"number"}},{"name":"limit","required":true,"in":"query","description":"Maximum number of records to return","schema":{"minimum":1,"maximum":200,"type":"number"}}],"responses":{"200":{"description":"Successfully retrieved activities","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ListActivitiesResponseDto"}}}},"400":{"description":"Invalid query parameters","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ValidationExceptionDto"}}}},"404":{"description":"The requested resource was not found.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExceptionDto"}}}},"500":{"description":"Unexpected internal error while processing activities.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExceptionDto"}}}}},"tags":["Activities"]}}}}
```

## Create activity

> Creates a new activity.

```json
{"openapi":"3.0.0","info":{"title":"Flosum Devops Api","version":"1.136.0-dev.5"},"security":[{"access-token":[]}],"components":{"securitySchemes":{"access-token":{"scheme":"bearer","bearerFormat":"JWT","type":"http","description":"Bearer access_token"}},"schemas":{"CreateActivityBodyDto":{"type":"object","properties":{"type":{"$ref":"#/components/schemas/JobType"},"deployManifest":{"description":"Manifest for Deploy type.","allOf":[{"$ref":"#/components/schemas/DeployManifestDto"}]},"validateManifest":{"description":"Manifest for Validate type.","allOf":[{"$ref":"#/components/schemas/ValidateManifestDto"}]},"mergeManifest":{"$ref":"#/components/schemas/MergeManifestDto"},"retrieveManifest":{"description":"Manifest for Retrieve type.","allOf":[{"$ref":"#/components/schemas/RetrieveManifestDto"}]},"retrieveComponentUsersManifest":{"$ref":"#/components/schemas/RetrieveComponentUsersManifestDto"},"searchAndReplaceManifest":{"$ref":"#/components/schemas/SearchAndReplaceManifestDto"},"commitToBranchManifest":{"$ref":"#/components/schemas/CommitToBranchManifestDto"},"quickDeployManifest":{"$ref":"#/components/schemas/QuickDeployManifestDto"},"overwriteProtectionManifest":{"$ref":"#/components/schemas/OverwriteProtectionManifestDto"},"migrationManifest":{"$ref":"#/components/schemas/MigrationManifestDto"},"preDeployFixSearchManifest":{"$ref":"#/components/schemas/PreDeployFixSearchManifestDto"},"preDeployFixRetrieveManifest":{"$ref":"#/components/schemas/PreDeployFixRetrieveManifestDto"},"preDeployFixRemoveManifest":{"$ref":"#/components/schemas/PreDeployFixRemoveManifestDto"},"preDeployFixUpdateManifest":{"$ref":"#/components/schemas/PreDeployFixUpdateManifestDto"},"rollbackManifest":{"$ref":"#/components/schemas/RollbackManifestDto"}},"required":["type"]},"JobType":{"type":"string","description":"Activity type.","enum":["Retrieve","Commit To Branch","Deploy","Search Conflicts","Validate","Merge","Pre-Deploy Fix Search","Pre-Deploy Fix Retrieve","Pre-Deploy Fix Remove","Rollback","Overwrite Protection","WebHook","Code Scan","Execute Apex","Push to Git","Pull from Git","Quick Deploy","Notify Unregistered Users","Notify Users Activity Digest","Retrieve Component Users","Migration","Pre-Deploy Fix Update","Migrate Data","Search and Replace Text"]},"DeployManifestDto":{"type":"object","properties":{"branchId":{"type":"number","description":"The ID of the branch to deploy from."},"organizationId":{"type":"number","description":"The ID of the target Salesforce organization to deploy to."},"componentIds":{"description":"IDs of components to deploy.","type":"array","items":{"type":"number"}},"selectAll":{"type":"boolean","description":"When true, deploys all components in the branch."},"search":{"type":"string","description":"Text filter for component names."},"types":{"description":"Metadata type names to include.","type":"array","items":{"type":"string"}},"updatedByIds":{"description":"Filter components by Flosum updater user ids.","type":"array","items":{"type":"number"}},"externalUpdatedBy":{"description":"Filter components by Salesforce updater names.","type":"array","items":{"type":"string"}},"startUpdatedAt":{"format":"date-time","type":"string","description":"Filter by Flosum updatedAt start."},"endUpdatedAt":{"format":"date-time","type":"string","description":"Filter by Flosum updatedAt end."},"startExternalUpdatedAt":{"format":"date-time","type":"string","description":"Filter by Salesforce updatedAt start."},"endExternalUpdatedAt":{"format":"date-time","type":"string","description":"Filter by Salesforce updatedAt end."},"origin":{"description":"Filter by component origins.","type":"array","items":{"type":"string"}},"organizationProperties":{"description":"Salesforce-specific deployment options.","allOf":[{"$ref":"#/components/schemas/OrganizationPropertiesDto"}]}},"required":["branchId","organizationId","componentIds","selectAll","organizationProperties"]},"OrganizationPropertiesDto":{"type":"object","properties":{"selectAllDestructiveChanges":{"type":"boolean","description":"When true, all destructive changes are included in the deployment."},"destructiveChangeIds":{"description":"IDs of destructive changes to include.","type":"array","items":{"type":"number"}},"searchDestructiveChanges":{"type":"string","description":"Text filter for destructive change names."},"typesDestructiveChanges":{"description":"Metadata type names to include in destructive changes.","type":"array","items":{"type":"string"}},"testLevel":{"$ref":"#/components/schemas/TestLevel"},"tests":{"description":"Apex test classes to run when testLevel is RunSpecifiedTests.","type":"array","items":{"type":"string"}},"isPartialProfileDeploy":{"type":"boolean","description":"When true, deploys only profile permissions from the package. All other org permissions remain unchanged."},"isPartialPermissionSetDeploy":{"type":"boolean","description":"When true, deploys only permission set entries from the package. Existing org entries are preserved."},"ignoreWarnings":{"type":"boolean","description":"Continue the deployment even if Salesforce returns warnings."},"postDeployApex":{"type":"string","description":"Apex code to execute after a successful deployment."},"isVlocityLwcActivation":{"type":"boolean","description":"Activate Vlocity LWC components after deployment."},"dataKitActivationIsEnabled":{"type":"boolean","description":"Activate DataKit components after deployment."},"isVlocityVerboseLogs":{"type":"boolean","description":"Enable verbose logging for Vlocity deployment operations."}},"required":["selectAllDestructiveChanges","destructiveChangeIds"]},"TestLevel":{"type":"string","enum":["NoTestRun","RunSpecifiedTests","RunLocalTests","RunAllTestsInOrg","RunRelevantTests","Default"]},"ValidateManifestDto":{"type":"object","properties":{"branchId":{"type":"number","description":"ID of the organization"},"organizationId":{"type":"number","description":"ID of the organization"},"componentIds":{"description":"IDs of components to deploy.","type":"array","items":{"type":"number"}},"selectAll":{"type":"boolean","description":"When true, deploys all components in the branch."},"search":{"type":"string","description":"Text filter for component names."},"types":{"description":"Metadata type names to include.","type":"array","items":{"type":"string"}},"updatedByIds":{"type":"array","items":{"type":"number"}},"externalUpdatedBy":{"type":"array","items":{"type":"string"}},"startUpdatedAt":{"format":"date-time","type":"string"},"endUpdatedAt":{"format":"date-time","type":"string"},"startExternalUpdatedAt":{"format":"date-time","type":"string"},"endExternalUpdatedAt":{"format":"date-time","type":"string"},"origin":{"type":"array","items":{"type":"string"}},"organizationProperties":{"$ref":"#/components/schemas/ValidateOrganizationPropertiesDto"}},"required":["branchId","organizationId","componentIds","selectAll","organizationProperties"]},"ValidateOrganizationPropertiesDto":{"type":"object","properties":{"selectAllDestructiveChanges":{"type":"boolean","description":"When true, all destructive changes are included in the deployment."},"destructiveChangeIds":{"description":"IDs of destructive changes to include.","type":"array","items":{"type":"number"}},"searchDestructiveChanges":{"type":"string","description":"Text filter for destructive change names."},"typesDestructiveChanges":{"description":"Metadata type names to include in destructive changes.","type":"array","items":{"type":"string"}},"testLevel":{"$ref":"#/components/schemas/TestLevel"},"tests":{"description":"Apex test classes to run when testLevel is RunSpecifiedTests.","type":"array","items":{"type":"string"}},"ignoreWarnings":{"type":"boolean"},"isPartialProfileValidate":{"type":"boolean"},"isPartialPermissionSetValidate":{"type":"boolean"}},"required":["selectAllDestructiveChanges","destructiveChangeIds"]},"MergeManifestDto":{"type":"object","properties":{"source":{"$ref":"#/components/schemas/MergeActivitySource"},"targetBranchId":{"type":"number"},"sourceBranchId":{"type":"number"},"pullRequestId":{"type":"number"}},"required":["source"]},"MergeActivitySource":{"type":"string","enum":["branch","pull_request"]},"RetrieveManifestDto":{"type":"object","properties":{"organizationId":{"type":"number","description":"The ID of the Salesforce organization to retrieve metadata from."},"declarativeFilterLine":{"description":"Optional filter conditions for retrieve.","type":"array","items":{"$ref":"#/components/schemas/DeclarativeFilterLineDto"}},"customLogic":{"type":"string","description":"Logical expression for combining filter lines.","nullable":true},"vlocityDeclarativeFilterLine":{"description":"Optional filter conditions for Vlocity retrieve.","type":"array","items":{"$ref":"#/components/schemas/VlocityDeclarativeFilterLineDto"}},"vlocityCustomLogic":{"type":"string","description":"Logical expression for combining Vlocity filter lines.","nullable":true}},"required":["organizationId"]},"DeclarativeFilterLineDto":{"type":"object","properties":{"field":{"type":"string","description":"The metadata field to filter on (e.g. type, name).","enum":["createdById","createdByName","createdDate","fileName","fullName","id","lastModifiedById","lastModifiedByName","lastModifiedDate","manageableState","namespacePrefix","type"]},"option":{"$ref":"#/components/schemas/DeclarativeFilterOptions"},"value":{"type":"string"}},"required":["field","option","value"]},"DeclarativeFilterOptions":{"type":"string","enum":["equals","not equals","less than","greater than","less or equals","greater or equals","contains","does not contain","starts with","includes","excludes","in","not in"]},"VlocityDeclarativeFilterLineDto":{"type":"object","properties":{"field":{"type":"string","description":"The Vlocity field to filter on.","enum":["Name","CreatedDate","LastModifiedDate","VlocityDataPackType","CreatedByName","LastModifiedByName","VlocityDataPackDisplayLabel","VlocityDataPackKey"]},"option":{"$ref":"#/components/schemas/DeclarativeFilterOptions"},"value":{"type":"string"}},"required":["field","option","value"]},"RetrieveComponentUsersManifestDto":{"type":"object","properties":{"organizationId":{"type":"number","description":"The ID of the Salesforce organization to retrieve users from."},"declarativeFilterLines":{"description":"Optional filter conditions for retrieve.","type":"array","items":{"$ref":"#/components/schemas/DeclarativeFilterLineDto"}},"customLogic":{"type":"string","description":"Logical expression for combining filter lines.","nullable":true}},"required":["organizationId"]},"SearchAndReplaceManifestDto":{"type":"object","properties":{"message":{"type":"string"},"searchText":{"type":"string"},"replaceText":{"type":"string"},"selectAll":{"type":"boolean"},"componentIds":{"type":"array","items":{"type":"number"}},"types":{"type":"array","items":{"type":"string"}},"search":{"type":"string","description":"Filter components by name or label before search and replace"},"updatedByIds":{"type":"array","items":{"type":"number"}},"externalUpdatedBy":{"type":"array","items":{"type":"string"}},"startUpdatedAt":{"format":"date-time","type":"string"},"endUpdatedAt":{"format":"date-time","type":"string"},"startExternalUpdatedAt":{"format":"date-time","type":"string"},"endExternalUpdatedAt":{"format":"date-time","type":"string"},"origin":{"type":"array","items":{"type":"string"}},"branchId":{"type":"number"}},"required":["message","searchText","replaceText","selectAll","branchId"]},"CommitToBranchManifestDto":{"type":"object","properties":{"branchId":{"type":"number","description":"The ID of the branch to commit components into."},"organizationId":{"type":"number","description":"The ID of the target Salesforce organization."},"message":{"type":"string","description":"Commit message that will be used for the new commit."},"componentIds":{"description":"IDs of components to include in the commit.","type":"array","items":{"type":"number"}},"selectAll":{"type":"boolean","description":"When true, commits all branch components except excluded IDs."},"search":{"type":"string","description":"Optional text filter for component names."},"types":{"description":"Optional list of metadata types to include.","type":"array","items":{"type":"string"}},"startExternalUpdatedAt":{"format":"date-time","type":"string","description":"Filter components with external_updated_at >= this date."},"endExternalUpdatedAt":{"format":"date-time","type":"string","description":"Filter components with external_updated_at <= this date."},"startCreatedAt":{"format":"date-time","type":"string","description":"Filter components with created_at >= this date."},"endCreatedAt":{"format":"date-time","type":"string","description":"Filter components with created_at <= this date."},"externalUpdatedBy":{"description":"Filter components by external updated by user ids.","type":"array","items":{"type":"string"}},"createdBy":{"description":"Filter components by created by system user ids.","type":"array","items":{"type":"number"}}},"required":["branchId","organizationId","message","componentIds","selectAll"]},"QuickDeployManifestDto":{"type":"object","properties":{"deploymentId":{"type":"number"}},"required":["deploymentId"]},"OverwriteProtectionManifestDto":{"type":"object","properties":{"branchId":{"type":"number"},"organizationId":{"type":"number"},"componentIds":{"type":"array","items":{"type":"number"}},"selectAll":{"type":"boolean"},"search":{"type":"string"},"types":{"type":"array","items":{"type":"string"}},"updatedByIds":{"type":"array","items":{"type":"number"}},"externalUpdatedBy":{"type":"array","items":{"type":"string"}},"startUpdatedAt":{"format":"date-time","type":"string"},"endUpdatedAt":{"format":"date-time","type":"string"},"startExternalUpdatedAt":{"format":"date-time","type":"string"},"endExternalUpdatedAt":{"format":"date-time","type":"string"},"origin":{"type":"array","items":{"type":"string"}}},"required":["branchId","organizationId","componentIds","selectAll"]},"MigrationManifestDto":{"type":"object","properties":{"token":{"type":"string"},"organizationIds":{"type":"array","items":{"type":"string"}},"userIds":{"type":"array","items":{"type":"string"}},"adminUserId":{"type":"string"},"repositoryId":{"type":"string"},"ignoreNamespace":{"type":"boolean"}},"required":["token","adminUserId","repositoryId"]},"PreDeployFixSearchManifestDto":{"type":"object","properties":{"branchId":{"type":"number"},"organizationId":{"type":"number"}},"required":["branchId","organizationId"]},"PreDeployFixRetrieveManifestDto":{"type":"object","properties":{"branchId":{"type":"number"},"preDeployFixSearchId":{"type":"number"},"organizationId":{"type":"number"},"dependencyIds":{"type":"array","items":{"type":"number"}},"message":{"type":"string"},"selectAll":{"type":"boolean"},"search":{"type":"string"},"types":{"type":"array","items":{"type":"string"}}},"required":["branchId","preDeployFixSearchId","organizationId","dependencyIds","message","selectAll"]},"PreDeployFixRemoveManifestDto":{"type":"object","properties":{"branchId":{"type":"number"},"preDeployFixSearchId":{"type":"number"},"selectAll":{"type":"boolean"},"dependencyIds":{"type":"array","items":{"type":"number"}},"message":{"type":"string"},"search":{"type":"string"},"types":{"type":"array","items":{"type":"string"}}},"required":["branchId","preDeployFixSearchId","selectAll","dependencyIds","message"]},"PreDeployFixUpdateManifestDto":{"type":"object","properties":{"branchId":{"type":"number"},"preDeployFixSearchId":{"type":"number"},"selectAll":{"type":"boolean"},"apiVersionIds":{"type":"array","items":{"type":"number"}},"message":{"type":"string"},"search":{"type":"string"},"types":{"type":"array","items":{"type":"string"}}},"required":["branchId","preDeployFixSearchId","selectAll","apiVersionIds","message"]},"RollbackManifestDto":{"type":"object","properties":{"branchId":{"type":"number"},"deployId":{"type":"number"},"selectAll":{"type":"boolean"},"deploymentChangeIds":{"type":"array","items":{"type":"number"}},"search":{"type":"string","description":"Text filter for deployment change name or label."},"types":{"description":"Metadata type names to include in rollback.","type":"array","items":{"type":"string"}},"status":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentStatus"}}},"required":["branchId","deployId","selectAll","deploymentChangeIds"]},"DeploymentStatus":{"type":"string","enum":["Changed","Created"]},"CreateActivityResponseDto":{"type":"object","properties":{"activityId":{"type":"number","description":"Unique identifier of the newly created activity."}},"required":["activityId"]},"ValidationExceptionDto":{"type":"object","properties":{"message":{"type":"array","items":{"type":"string"}},"error":{"type":"string","nullable":true},"statusCode":{"type":"number","enum":[100,101,102,103,200,201,202,203,204,205,206,300,301,302,303,304,307,308,400,401,402,403,404,405,406,407,408,409,410,411,412,413,414,415,416,417,418,421,422,424,428,429,500,501,502,503,504,505]}},"required":["message","error","statusCode"]},"ExceptionDto":{"type":"object","properties":{"message":{"type":"string"},"error":{"type":"string"},"statusCode":{"type":"number","enum":[400,401,403,404,405,406,408,409,410,412,413,414,415,418,420,422,428,429,431,500,502,503,504]}},"required":["message","error","statusCode"]}}},"paths":{"/topologies/{topologyId}/activities":{"post":{"operationId":"ActivitiesController_create","summary":"Create activity","description":"Creates a new activity.","parameters":[{"name":"topologyId","required":true,"in":"path","schema":{"type":"number"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateActivityBodyDto"}}}},"responses":{"201":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateActivityResponseDto"}}}},"400":{"description":"Invalid activity payload.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ValidationExceptionDto"}}}},"404":{"description":"A required related resource was not found.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExceptionDto"}}}},"409":{"description":"The request conflicts with the current state of the resource.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExceptionDto"}}}},"500":{"description":"Unexpected internal error while processing activities.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExceptionDto"}}}}},"tags":["Activities"]}}}}
```

## Get activity by id

> Returns detailed information about the specified activity.

```json
{"openapi":"3.0.0","info":{"title":"Flosum Devops Api","version":"1.136.0-dev.5"},"security":[{"access-token":[]}],"components":{"securitySchemes":{"access-token":{"scheme":"bearer","bearerFormat":"JWT","type":"http","description":"Bearer access_token"}},"schemas":{"GetActivityResponseDto":{"type":"object","properties":{"id":{"type":"number","description":"Unique identifier of the activity."},"type":{"$ref":"#/components/schemas/JobType"},"status":{"$ref":"#/components/schemas/JobStatus"},"source":{"nullable":true,"description":"Source entity of the activity.","allOf":[{"$ref":"#/components/schemas/SourceTargetDto"}]},"target":{"nullable":true,"description":"Target entity of the activity.","allOf":[{"$ref":"#/components/schemas/SourceTargetDto"}]},"createdBy":{"nullable":true,"description":"User who created the activity.","allOf":[{"$ref":"#/components/schemas/UserRecordDto"}]},"createdAt":{"format":"date-time","type":"string","description":"Timestamp when the activity was created."},"completedAt":{"type":"string","nullable":true,"description":"Null if the job has not yet completed."},"duration":{"type":"string","nullable":true,"description":"Execution time in `HH:MM:SS` format."},"codeScan":{"$ref":"#/components/schemas/CodeScanActivityResponseDto"},"gitSync":{"$ref":"#/components/schemas/GitSyncActivityResponseDto"},"commitContext":{"$ref":"#/components/schemas/CommitActivityResponseDto"},"deployContext":{"$ref":"#/components/schemas/DeployActivityResponseDto"},"validationContext":{"$ref":"#/components/schemas/ValidationActivityResponseDto"},"searchConflictContext":{"$ref":"#/components/schemas/SearchConflictsActivityResponseDto"},"retrieveContext":{"$ref":"#/components/schemas/RetrieveActivityResponseDto"},"overwriteProtectionContext":{"$ref":"#/components/schemas/OverwriteProtectionActivityResponseDto"},"mergeContext":{"$ref":"#/components/schemas/MergeActivityResponseDto"},"quickDeployContext":{"$ref":"#/components/schemas/QuickDeployActivityResponseDto"},"preDeployFixSearchContext":{"$ref":"#/components/schemas/PreDeployFixSearchActivityResponseDto"},"preDeployFixRetrieveContext":{"$ref":"#/components/schemas/PreDeployFixRetrieveActivityResponseDto"},"preDeployFixRemoveContext":{"$ref":"#/components/schemas/PreDeployFixRemoveActivityResponseDto"},"preDeployFixUpdateContext":{"$ref":"#/components/schemas/PreDeployFixUpdateActivityResponseDto"},"rollbackContext":{"$ref":"#/components/schemas/RollbackActivityResponseDto"},"searchAndReplaceContext":{"$ref":"#/components/schemas/SearchAndReplaceActivityResponseDto"},"retrieveComponentUsersContext":{"$ref":"#/components/schemas/RetrieveComponentUsersActivityResponseDto"},"migrationContext":{"$ref":"#/components/schemas/MigrationActivityResponseDto"}},"required":["id","type","status","createdAt"]},"JobType":{"type":"string","description":"Activity type.","enum":["Retrieve","Commit To Branch","Deploy","Search Conflicts","Validate","Merge","Pre-Deploy Fix Search","Pre-Deploy Fix Retrieve","Pre-Deploy Fix Remove","Rollback","Overwrite Protection","WebHook","Code Scan","Execute Apex","Push to Git","Pull from Git","Quick Deploy","Notify Unregistered Users","Notify Users Activity Digest","Retrieve Component Users","Migration","Pre-Deploy Fix Update","Migrate Data","Search and Replace Text"]},"JobStatus":{"type":"string","description":"Current execution status of the activity.","enum":["In Progress","Partially Completed","Exception","Completed","Aborted","Queued"]},"SourceTargetDto":{"type":"object","properties":{"id":{"type":"number","description":"Entity ID. Null for Git type.","nullable":true},"type":{"$ref":"#/components/schemas/SourceTargetType"},"name":{"type":"string","description":"Entity name"},"metadata":{"description":"Additional metadata. Populated for Organization type only. Null for Branch and Git types.","nullable":true,"allOf":[{"$ref":"#/components/schemas/SourceTargetMetadataDto"}]}},"required":["id","type","name"]},"SourceTargetType":{"type":"string","description":"Entity type","enum":["Branch","Organization","Git"]},"SourceTargetMetadataDto":{"type":"object","properties":{"organizationType":{"type":"string","description":"Salesforce org type"},"connectionType":{"type":"string","description":"Connection type"},"environment":{"type":"string","description":"Environment label"},"assignApps":{"description":"Apps assigned to this org","allOf":[{"$ref":"#/components/schemas/AssignAppsDto"}]},"externalId":{"type":"string","description":"Salesforce org external ID"}},"required":["organizationType","connectionType","environment","assignApps","externalId"]},"AssignAppsDto":{"type":"object","properties":{"backupAndArchive":{"type":"boolean","description":"Whether Backup & Archive app is assigned"},"devOps":{"type":"boolean","description":"Whether DevOps app is assigned"},"dataMigrator":{"type":"boolean","description":"Whether Data Migrator app is assigned"}},"required":["backupAndArchive","devOps","dataMigrator"]},"UserRecordDto":{"type":"object","properties":{"id":{"type":"number"},"name":{"type":"string"}},"required":["id","name"]},"CodeScanActivityResponseDto":{"type":"object","properties":{"codeScanId":{"type":"number","nullable":true},"severityThreshold":{"type":"object"},"description":{"type":"object","nullable":true},"checkType":{"type":"string"},"branch":{"type":"string"}},"required":["codeScanId","severityThreshold","description","checkType","branch"]},"GitSyncActivityResponseDto":{"type":"object","properties":{"syncId":{"type":"number"}},"required":["syncId"]},"CommitActivityResponseDto":{"type":"object","properties":{"commitId":{"type":"number","nullable":true},"organizationId":{"type":"number"},"componentIds":{"type":"array","items":{"type":"number"}},"branchId":{"type":"number"},"message":{"type":"string"},"userId":{"type":"number"},"selectAll":{"type":"boolean"},"types":{"type":"array","items":{"type":"string"}},"search":{"type":"string"}},"required":["commitId","organizationId","branchId","message","userId","selectAll"]},"DeployActivityResponseDto":{"type":"object","properties":{"deploymentId":{"type":"number","nullable":true},"organizationId":{"type":"number"},"branchId":{"type":"number"},"selectAll":{"type":"boolean"},"componentIds":{"type":"array","items":{"type":"number"}},"organizationProperties":{"type":"object"},"types":{"type":"array","items":{"type":"string"}}},"required":["deploymentId","organizationId","branchId","selectAll","organizationProperties"]},"ValidationActivityResponseDto":{"type":"object","properties":{"deploymentId":{"type":"number","nullable":true},"branchId":{"type":"number"},"organizationId":{"type":"number"},"componentIds":{"type":"array","items":{"type":"number"}},"selectAll":{"type":"boolean"},"organizationProperties":{"type":"object"},"search":{"type":"string"},"types":{"type":"array","items":{"type":"string"}}},"required":["deploymentId","branchId","organizationId","selectAll","organizationProperties"]},"SearchConflictsActivityResponseDto":{"type":"object","properties":{"searchConflictId":{"type":"number","nullable":true}},"required":["searchConflictId"]},"RetrieveActivityResponseDto":{"type":"object","properties":{"retrieveId":{"type":"number","nullable":true},"organizationId":{"type":"number"},"userId":{"type":"number"}},"required":["retrieveId","organizationId","userId"]},"OverwriteProtectionActivityResponseDto":{"type":"object","properties":{"overwriteProtectionId":{"type":"number","nullable":true},"organizationId":{"type":"number"},"branchId":{"type":"number"},"selectAll":{"type":"boolean"},"componentIds":{"type":"array","items":{"type":"number"}},"organizationProperties":{"type":"object"},"types":{"type":"array","items":{"type":"string"}}},"required":["overwriteProtectionId","organizationId","branchId","selectAll"]},"MergeActivityResponseDto":{"type":"object","properties":{"targetBranchId":{"type":"number"},"sourceBranchId":{"type":"number"},"userId":{"type":"number"},"mergeType":{"type":"string"}},"required":["targetBranchId","sourceBranchId","userId","mergeType"]},"QuickDeployActivityResponseDto":{"type":"object","properties":{"deploymentId":{"type":"number","nullable":true},"branchId":{"type":"number"},"organizationId":{"type":"number"},"validationDeploymentId":{"type":"number"},"salesforceValidateId":{"type":"string"}},"required":["deploymentId","branchId","organizationId","validationDeploymentId","salesforceValidateId"]},"PreDeployFixSearchActivityResponseDto":{"type":"object","properties":{"preDeployFixSearchId":{"type":"number","nullable":true},"branchId":{"type":"number"},"organizationId":{"type":"number"}},"required":["preDeployFixSearchId","branchId","organizationId"]},"PreDeployFixRetrieveActivityResponseDto":{"type":"object","properties":{"preDeployFixRetrieveId":{"type":"number","nullable":true},"userId":{"type":"number"},"branchId":{"type":"number"},"organizationId":{"type":"number"},"message":{"type":"string"},"selectAll":{"type":"boolean"},"dependencyIds":{"type":"array","items":{"type":"number"}}},"required":["preDeployFixRetrieveId","userId","branchId","organizationId","message","selectAll","dependencyIds"]},"PreDeployFixRemoveActivityResponseDto":{"type":"object","properties":{"preDeployFixRemoveId":{"type":"number","nullable":true},"userId":{"type":"number"},"branchId":{"type":"number"},"message":{"type":"string"},"selectAll":{"type":"boolean"},"dependencyIds":{"type":"array","items":{"type":"number"}},"organizationId":{"type":"number"}},"required":["preDeployFixRemoveId","userId","branchId","message","selectAll","dependencyIds","organizationId"]},"PreDeployFixUpdateActivityResponseDto":{"type":"object","properties":{"preDeployFixUpdateId":{"type":"number","nullable":true},"userId":{"type":"number"},"branchId":{"type":"number"},"message":{"type":"string"},"selectAll":{"type":"boolean"},"apiVersionIds":{"type":"array","items":{"type":"number"}},"organizationId":{"type":"number"}},"required":["preDeployFixUpdateId","userId","branchId","message","selectAll","apiVersionIds","organizationId"]},"RollbackActivityResponseDto":{"type":"object","properties":{"deploymentId":{"type":"number","nullable":true},"organizationId":{"type":"number"},"selectAll":{"type":"boolean"},"deploymentChangeIds":{"type":"array","items":{"type":"number"}},"search":{"type":"string"},"types":{"type":"array","items":{"type":"string"}},"status":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentStatus"}}},"required":["deploymentId","organizationId","selectAll","deploymentChangeIds"]},"DeploymentStatus":{"type":"string","enum":["Changed","Created"]},"SearchAndReplaceActivityResponseDto":{"type":"object","properties":{"searchAndReplaceId":{"type":"number","nullable":true},"commitId":{"type":"number","nullable":true},"branchId":{"type":"number"},"message":{"type":"string"},"searchText":{"type":"string"},"replaceText":{"type":"string"},"selectAll":{"type":"boolean"},"componentIds":{"type":"array","items":{"type":"number"}},"userId":{"type":"number"},"types":{"type":"array","items":{"type":"string"}},"search":{"type":"string"}},"required":["searchAndReplaceId","commitId","branchId","message","searchText","replaceText","selectAll","componentIds","userId"]},"RetrieveComponentUsersActivityResponseDto":{"type":"object","properties":{"organizationId":{"type":"number"},"declarativeFilterLines":{"nullable":true,"type":"array","items":{"type":"object"}},"customLogic":{"type":"string","nullable":true}},"required":["organizationId"]},"MigrationActivityResponseDto":{"type":"object","properties":{"migrationRequestId":{"type":"number","nullable":true},"dataMigratorRequestId":{"type":"number","nullable":true},"userId":{"type":"number"},"tenantName":{"type":"string"},"adminUserId":{"type":"string"},"repositoryId":{"type":"string"},"organizationIds":{"type":"array","items":{"type":"string"}},"userIds":{"type":"array","items":{"type":"string"}},"ignoreNamespace":{"type":"boolean"}},"required":["migrationRequestId","dataMigratorRequestId","userId","tenantName","adminUserId","repositoryId"]},"ValidationExceptionDto":{"type":"object","properties":{"message":{"type":"array","items":{"type":"string"}},"error":{"type":"string","nullable":true},"statusCode":{"type":"number","enum":[100,101,102,103,200,201,202,203,204,205,206,300,301,302,303,304,307,308,400,401,402,403,404,405,406,407,408,409,410,411,412,413,414,415,416,417,418,421,422,424,428,429,500,501,502,503,504,505]}},"required":["message","error","statusCode"]},"ExceptionDto":{"type":"object","properties":{"message":{"type":"string"},"error":{"type":"string"},"statusCode":{"type":"number","enum":[400,401,403,404,405,406,408,409,410,412,413,414,415,418,420,422,428,429,431,500,502,503,504]}},"required":["message","error","statusCode"]}}},"paths":{"/topologies/{topologyId}/activities/{activityId}":{"get":{"operationId":"ActivitiesController_get","summary":"Get activity by id","description":"Returns detailed information about the specified activity.","parameters":[{"name":"topologyId","required":true,"in":"path","schema":{"type":"number"}},{"name":"activityId","required":true,"in":"path","schema":{"type":"number"}}],"responses":{"200":{"description":"Successfully retrieved activity","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetActivityResponseDto"}}}},"400":{"description":"Invalid path parameters","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ValidationExceptionDto"}}}},"404":{"description":"Activity not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExceptionDto"}}}},"500":{"description":"Unexpected internal error while processing activities.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExceptionDto"}}}}},"tags":["Activities"]}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.flosum.com/api/api-es/api-de-devops/activities.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
